/*
*/
/*******************************************************************************
														MULTI-EDIT MACRO FILE

Name: CONV_700

CONV_700				- Converts version 5.00 and up to be compatible with 7.00
REPLACE_HEADER	- Replaces headers in DB files.  To be used only by CONV_700
CHECK_KEYMAP		- Processes keymaps to be 7.0 compatible.  Only for CONV_700
CONV_INSTALL		- Informs user of instructions for use.

							 (C) Copyright 1991 by American Cybernetics, Inc.
*******************************************************************************/
macro CONV_700 DUMP {
/*******************************************************************************
																MULTI-EDIT MACRO

Name: CONV_700

Description: Converts version 5.00 and up to be compatible with 7.00

							 (C) Copyright 1991 by American Cybernetics, Inc.
*******************************************************************************/
	int Active_Window = Window_Id,
					Convert_Mode,
					Db_Window = 0,
					Data_Window = 0,
					Meconfig_Window = 0,
					T_File_Search_Attr = File_Search_Attr,
					T_Undo_Stat = Undo_Stat,
					T_Insert_Mode = Insert_Mode,
					T_Int,
					None_Exists,
					Check_Import,
					No_Import,
					No_Import_Meconfig,
					No_Import_Init,
					No_Import_Keymap,
					FNF_Ignore,
					Printers_Found,
					T_Box_Count = Box_Count,
					menu = menu_create,
					mono,
					T_Flag,
					old_is_5 = false,
					abort_flag = false
					;
/*
int what = window_count;
*/
	str T_File_Search_Rec[64] = File_Search_Rec,
					T_Str,
					T_Line[2048],
					Old_Path,
					T_User_Id = User_Id,
					Old_File_Name[80],
					t_serial = "",
					compile_tmp_name[120]
					;

	Refresh = False;

// Mod to handle correct placement of .TMP files
	RM("TMP_FILE_NAME /FN=SETER.TMP");
	compile_tmp_name = return_str;

	intr($11);
	mono = ((r_ax & $0030) == $0030);

/* Due to an incompatibility, we will get rid of all calculator tape global
strings */
	t_int = 1;
	while (Global_Str("Calc_Tape" + Str(t_int)) != "") {
		Set_Global_Str("Calc_Tape" + Str(t_int),"");
		++t_int;
	}


/*
CONVERT_MODE := 1;
OLD_PATH := 'G:\MEWORK\500\';
GOTO LOAD_DATA;
 */
/*
	Put_Box(9,3,49,23,0,M_B_Color,'7.0 CONVERSION',1);
	Write('Ķ',9,7,0,M_B_Color);
	Write('Choosing "Automatically" will import',    10,8,0,M_B_Color);
	Write('ALL existing configuration files from', 10,9,0,M_B_Color);
	Write('the previous version.',             10,10,0,M_B_Color);
	Write('Choosing "Interactively" will prompt'    ,10,12,0,M_B_Color);
	Write('you on any occurance of a configura-'     ,10,13,0,M_B_Color);
	Write('tion file that exists in both the',10,14,0,M_B_Color);
	Write('old, and the new version, for you to'      ,10,15,0,M_B_Color);
	Write('decide whether or not to import it.',10,16,0,M_B_Color);
	Write('Choosing "files only" will update'    ,10,18,0,M_B_Color);
	Write('only the existing configuration files',10,19,0,M_B_Color);
	Write('in the new version and NOT import',10,20,0,M_B_Color);
	Write('anything from the previous version.',10,21,0,M_B_Color);

	RM('USERIN^XMENU /X=10/Y=4/B=0/T=1/M=' +
			'Update from version 5.x Automatically()' +
			'update from Version 5.x Interactively()' +
			'update Configuration files only()');
	Kill_Box;
 */
	menu_set_item( menu, 1, 'Update from version >=5.0 Automatically','','/L=1/C=1/QK=25/R=1',11,0, 0);
	menu_set_item( menu, 2, 'Update from version >=5.0 Interactively','','/L=3/C=1/QK=25/R=12',11,0, 0);
	menu_set_item( menu, 3, 'Update configuration files only','','/L=5/C=1/QK=8/R=13',11,0, 0);
	menu_set_item( menu, 4, 'AUTOMATICALLY imports ALL existing configuration','','/L=7/C=1',10,0, 0);
	menu_set_item( menu, 5, 'files from the previous version','','/L=8/C=1',10,0, 0);
	menu_set_item( menu, 6, 'INTERACTIVELY prompts you on any occurance of a','','/L=10/C=1',10,0, 0);
	menu_set_item( menu, 7, 'configuration file that exists in both old, and','','/L=11/C=1',10,0, 0);
	menu_set_item( menu, 8, 'new versions, allowing you to decide on its conversion.','','/L=12/C=1',10,0, 0);
	menu_set_item( menu, 9, 'FILES ONLY updates only existing configuration files','','/L=14/C=1',10,0, 0);
	menu_set_item( menu, 10, 'in the new version and NOT import anything from','','/L=15/C=1',10,0, 0);
	menu_set_item( menu, 11, 'a previous version.','','/L=16/C=1',10,0, 0);

	return_int = menu;
	RM('USERIN^Data_In /HN=1/POSG=@CONVPOS@/PRE=PRD/A=0/S=1/#=11/T=7.0 CONVERSION');

	menu_delete( menu );

	if (Return_Int == 1) {
		Return_Int = 11;
	}

	if (Return_Int < 11) {
		Goto PROMPT_ABORT;
	}

	Convert_Mode = Return_Int - 10;
	if (Convert_Mode == 3) {
		Old_Path = Me_Path;
		Goto LOAD_DATA;
	}

PATH_PROMPT:
	Return_Str = '';
	RM('userin^QUERYBOX /L=5/W=60/ML=80/T=Input path to previous version (>=5.00) files or <ESC> to abort/F2=Dir   /L=3');
	if (Return_Int == 0) {
PROMPT_ABORT:
		Make_Message('7.00 conversion terminated by user.');
		Goto EXIT;
	}
	Return_Str = Fexpand(Return_Str);
	if (Copy(Return_Str,Length(Return_Str),1) != '\') {
		Return_Str = Return_Str + '\';
	}
	if (File_Exists(Return_Str + '*.*') == 0) {
		RM('MEERROR^MESSAGEBOX /B=1/T=ERROR/M=Path not found or directory empty.');
		Goto PATH_PROMPT;
	}
	Old_Path = Return_Str;
	if (Old_Path == Me_Path) {
		RM('MEERROR^MESSAGEBOX /B=1/T=ERROR/M=Previous version files MUST be in a separate directory than the 7.00 files.');
		Goto PATH_PROMPT;
	}
	if (File_Exists(Old_Path + 'MECONFIG.DB') == 0) {
		Beep;
		Make_Message('No MECONFIG.DB found in ' + Old_Path);
		Goto EXIT;
	}

	if (File_Exists(Old_Path + 'CMAC.EXE')) {
/*
		Return_str = "CONVPREP.600";
		if (t_int = copy_file(me_path + return_str,old_path + "CONVPREP.MAC",0)) {
			RM('MEERROR^MESSAGEBOX /T=CONVERSION ERROR/B=2/M=Error #' + str(t_int) +
				' copying ' +	me_path + return_str + " to " + old_path + "CONVPREP.MAC"
					);
			make_message("Conversion macro terminated.");
			goto EXIT;

		}

		Return_str = old_path + "ME.EXE /NR /R CONVPREP";
		Error_Level = 0;
		RM('MEUTIL1^EXEC /SCREEN=1/SWAP=2/MEM=0');
		if (exit_code) {
			RM('MEERROR^MESSAGEBOX /B=2/M=Error saving configuration while running pre-processor macro.' +
					'/T=CONVERSION ERROR');
			make_message("Conversion macro terminated.");
			goto EXIT;
		}
		del_file(old_path + "CONVPREP.MAC");
*/
	} else {
		old_is_5 = true;
	}


LOAD_DATA:
/* Find the users MECONFIG.DB file and get rid of it for now to simplify things
below */
	Reg_Exp_Stat = True;
	Ignore_Case = True;
	Return_Str = 'MECONFIG.DB';
	RM('MAKEUSERPATH');
	if (Switch_File(Return_Str)) {
		if (File_Changed) {
			Save_File;
		}
		Delete_Window;
	}

	User_Id = '';

		RM("SETUP^SETSERIAL");
		t_serial = Global_Str('@ME_SERIAL#');


	Undo_Stat = False;
	File_Search_Attr = $10;
	Create_Window;
	Data_Window = Window_Id;
	Error_Level = 0;
	Load_File(ME_PATH + 'CONV_700.DAT');
	if (Error_Level) {
		RM('MEERROR /EM=Error loading the data file: ' + ME_PATH +
				'CONV_700.DAT.  Conversion aborted.');
		Error_Level = 0;
		Goto EXIT;
	}
	Create_Window;
	Meconfig_Window = Window_Id;
	File_Name = Old_Path + 'MECONFIG.DB';
	Create_Window;
	Db_Window = Window_Id;

	File_Name = Old_Path + 'KEYMAC.DB';
	Call MERGE_KEYMAC;
	if (old_is_5) {
		Call CONVERT_USER_MENU;
	}
	if ((Convert_Mode != 3) & (No_Import_Meconfig == False)) {
/* Merge SPELLSET.ME with MECONFIG.DB if it exists */
		if (old_is_5) {
			Switch_Win_Id(Db_Window);
			File_Name = Old_Path + 'SPELLSET.ME';
			Call MERGE_SPELLSET;
		}
/* Replace all headers in MECOM.DB if it exists */
		Switch_Win_Id(Db_Window);
		File_Name = Old_Path + 'MECOM.DB';
		Call PROCESS_MECOM;
	}
	Switch_Win_Id(Db_Window);
	File_Name = Old_Path + 'PRINTERS.DB';
	Call CONVERT_PRINTERS;

	Call MECONFIG_HEADERS;

	if (Printers_Found) {
		Switch_Win_Id(Db_Window);
		Call PRINTERS_HEADERS;
	}

	Switch_Win_Id(Db_Window);
	File_Name = Old_Path + 'PHONE.DB';
	Call IMPORT_PHONE;

	RM('INIT');
	call INIT_PATHS;
	set_Global_Str('@ME_SERIAL#',t_serial);

	if (Convert_Mode != 3) {
		Switch_Win_Id(Db_Window);
		File_Name = Old_Path + 'INIT.S';
		Call CONVERT_INIT;
	}

	Switch_Win_Id(Db_Window);
/* Load the persons selected keymap file */
	File_Name = Old_Path + Parse_Str('FN=',Global_Str('@KEYMAP_NAME@')) + '.DB';
	Call CONVERT_KEYMAP;
/*
goto DONT_USE;
*/
	Call SAVE_INIT;

	if (First_File(Old_Path + '*.USR') == 0) {
GET_NEXT_USER:
		if (Last_File_Attr & $10) {
			User_Id = Truncate_Extension(Str_Del(Last_File_Name,Svl(Old_Path) + 1,7));
			Return_Str = '';
			RM('MAKEUSERPATH');
			Switch_Win_Id(Meconfig_Window);
			File_Name = Old_Path + Last_File_Name + '\MECONFIG.DB';
			Switch_Win_Id(Db_Window);
			File_Name = Old_Path + Last_File_Name + '\KEYMAC.DB';
			Call MERGE_KEYMAC;
			if (old_is_5) {
				Call CONVERT_USER_MENU;
			}

			if ((Convert_Mode != 3) & (No_Import_Meconfig == False)) {
/* Merge SPELLSET.ME with MECONFIG.DB if it exists */
				if (old_is_5) {
					Switch_Win_Id(Db_Window);
					File_Name = Old_Path + Last_File_Name + '\SPELLSET.ME';
					Call MERGE_SPELLSET;
				}
/* Replace all headers in MECOM.DB if it exists */
				Switch_Win_Id(Db_Window);
				File_Name = Old_Path + Last_File_Name + '\MECOM.DB';
				Call PROCESS_MECOM;
			}
			Switch_Win_Id(Db_Window);
			File_Name = Old_Path + Last_File_Name + '\PRINTERS.DB';
			Call CONVERT_PRINTERS;

			Call MECONFIG_HEADERS;

			if (Printers_Found) {
				Switch_Win_Id(Db_Window);
				Call PRINTERS_HEADERS;
			}

			Switch_Win_Id(Db_Window);
			File_Name = Old_Path + Last_File_Name + '\PHONE.DB';
			Call IMPORT_PHONE;

			RM(User_Id + 'INIT');
			Call INIT_PATHS;
			set_Global_Str('@ME_SERIAL#',t_serial);

			if (Convert_Mode != 3) {
				Switch_Win_Id(Db_Window);
				File_Name = Old_Path + Last_File_Name + '\' + User_Id + 'INIT.S';
				Call CONVERT_INIT;
			}

			Switch_Win_Id(Db_Window);
	/* Load the persons selected keymap file */
			File_Name = Old_Path + Last_File_Name + '\' + Parse_Str('FN=',Global_Str('@KEYMAP_NAME@')) + '.DB';
			Call CONVERT_KEYMAP;

			Call SAVE_INIT;

		}
		if (Next_File == 0) {
			Goto GET_NEXT_USER;
		}
	}

	Make_Message('7.00 CONVERSION IS COMPLETE.');

	Goto EXIT;

MERGE_KEYMAC:
	if (old_is_5)	{
		Return_Str = 'Converting keystroke macro file: ' + File_Name;
		Call WRITE_MESSAGE;
	}
	Switch_Win_Id(Meconfig_Window);
	No_Import_Meconfig = False;
	Check_Import = True;
	Call DO_LOAD_FILE;
	if ((No_Import == True) | (Error_Level != 0)) {
		No_Import_Meconfig = True;
		RET;
	}
	if ((Convert_Mode == 3) || (!old_is_5)) {
		Ret;
	}
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (Search_Fwd('%/TP=12/C=37/L=4/H=INKE/T=All /DBF=M/DBV=255$',0) == True) {
		RET;
	}

	Switch_Win_Id(Db_Window);
	Call DO_LOAD_FILE;
	if (Error_Level != 0) {
		No_Import_Meconfig = True;
		RET;
	}

	Return_Str = '%@*@*@*@*START@*@*@*@*$';
	Call VALIDITY_CHECK;

/* Merge KEYMAC.DB with MECONFIG.DB */
	Switch_Win_Id(Meconfig_Window);
	Tof;
	Insert_Mode = True;
	Cr;
	Up;
	Put_Line('|12KEYMAC.DB');
	Down;

	Call MERGE_TO_MECONFIG;
	if (Error_Level) {
		RET;
	}

	Ignore_Case = True;
	Reg_Exp_Stat = True;
	while (Search_Fwd('{M=}+[0-9]',0)) {
		T_Int = Parse_Int('M=',Get_Line);
		if (T_Int == 4) {
			T_Int = 255;
		} else if (T_Int == 3) {
/* No change needed for terminal */
		} else if (T_Int == 2) {
			--T_Int;
		} else {
			T_Int = 0;
		}
		Replace('#0' + Str(T_Int));
		Eol;
	}


/* Change all compiler/program setups to use in window so as to make everyone
aware of it's existence */
	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	while (Search_Fwd('%|12?+.PGM$',0)) {
		if (Caps(Found_Str) == '|12SRC.PGM') {
/* Macro source .SRC compiler command lines need to be altered to place the
.MAC file in the proper directory */
			T_Int = True;
		} else {
			T_Int = False;
		}
CHANGE_PGM:
		Down;
		if (Cur_Char == '') {
			if (T_Int) {
				Goto_Col(1);
				Ignore_Case = True;
				Reg_Exp_Stat = True;
				if (Search_Fwd('-P *<ME_PATH>',1)) {
					Goto_Col(C_Col + Length(Found_Str));
					Text('MAC\');
				}
				Goto_Col(1);
			}
			Set_Global_Str('@CHANGE_PGM',Get_Line);
			Return_Str = 'CS=';
			RM('USERIN^CHNGPARM /G=@CHANGE_PGM/P=3');
			Put_Line(Global_Str('@CHANGE_PGM'));
			Goto CHANGE_PGM;
		}
	}
	Set_Global_Str('@CHANGE_PGM','');
	RET;

CONVERT_USER_MENU:
	Switch_Win_Id(MECONFIG_Window);
	Tof;
	if (search_fwd('%|12USER.MNU',0)) {
		RET;
	}
	Return_Str = 'Converting converting user menu data in file: ' + File_Name;
	Call WRITE_MESSAGE;
	if (search_fwd('%|12USER.DB$',0)) {
		replace('|12USER.MNU /HZ=0/ED=1/M=');
		down;
		goto_Col(1);
/* strip old header */
		while ((xpos(cur_Char,'|12',1) == False) && (At_Eof == False)) {
			Del_Line;
		}
	}
	RET;

IMPORT_PHONE:
	if (Convert_Mode == 3) {
		RET;
	}
	Switch_Win_Id(Db_Window);
	Return_Str = 'Importing phone data file: ' + File_Name;
	Call WRITE_MESSAGE;
	FNF_Ignore = True;
	Check_Import = True;
	Call DO_LOAD_FILE;
	if (Error_Level) {
/* If there is no PHONE.DB, get out */
		Ret;
	}
	if (No_Import) {
		RET;
	}
	Call DO_SAVE_FILE;
	RET;

CONVERT_PRINTERS:
	Switch_Win_Id(Db_Window);
	None_Exists = 0;
	Return_Str = 'Converting printer data file: ' + File_Name;
	Call WRITE_MESSAGE;
	FNF_Ignore = True;
	Check_Import = True;
	Call DO_LOAD_FILE;
	if (Error_Level) {
/* If there is no PRINTERS.DB, get out */
		Printers_Found = 0;
		Ret;
	}
	Printers_Found = 1;
	if (No_Import || !old_is_5) {
		RET;
	}
	if (Convert_Mode == 3) {
		RET;
	}

	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (Search_Fwd('%|12PRINTERS.DB$',0) == True) {
		RET;
	}
	Insert_Mode = True;
	Cr;
	Up;
	Put_Line('|12PRINTERS.DB');
	if (Search_Fwd('PT=NONE',0) == False) {
		Eof;
		if (C_Col > 1) {
			Down;
		}
		Put_Line('PT=NONE');
	}
	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	Search_Fwd('%@*@*@*@*START@*@*@*@*$',0);
	Down;
	Goto_Col(1);
	while (Cur_Char == '') {
		T_Line = Get_Line;
		Put_Line('PT=' + Caps(Parse_Str('PT=',T_Line)));
		if (None_Exists == 0) {
			if (Get_Line == 'PT=NONE') {
				None_Exists = 1;
			}
		}
		Mark_Pos;
		Eof;
		if (C_Col > 1) {
			Down;
		}
		Put_Line('|12' + Parse_Str('PT=',T_Line) + '.PRT');
		Down;
		if (None_Exists == 1) {
/* Create a dummy header so that we can use REPLACE_HEADER later on */
			Put_Line('DUMMY HEADER');
			Down;
			Put_Line('****START****');
			Down;
			None_Exists = 2;
		}
/* Place a record for init and term strings whether the user has them or not */
		Put_Line('N=Initialization StringC=' + Parse_Str('IS=',T_Line));
		Down;
		Put_Line('N=Termination StringC=' + Parse_Str('TS=',T_Line));
		Down;

		T_Int = 0;
		while (T_Int < 18) {
			++T_Int;
			T_Str = '';
			if (Parse_Str('N' + Str(T_Int) + '=',T_Line) != '') {
				T_Str = T_Str + 'N=' + Parse_Str('N' + Str(T_Int) + '=',T_Line);
			}
			if (Parse_Str('F' + Str(T_Int) + '=',T_Line) != '') {
				T_Str = T_Str + 'F=' + Parse_Str('F' + Str(T_Int) + '=',T_Line);
			}
			if (Parse_Str('C' + Str(T_Int) + '=',T_Line) != '') {
				T_Str = T_Str + 'C=' + Parse_Str('C' + Str(T_Int) + '=',T_Line);
			}
			if (T_Str != '') {
				Put_Line(T_Str);
				Down;
			}
		}
		Goto_Mark;
		Down;
	}
	Call DO_SAVE_FILE;
	RET;

PROCESS_MECOM:
	switch_win_id(db_window);
	Old_File_Name = File_Name;
	Error_Level = 0;
	switch_win_id(db_window);
	Load_File(File_Name);
	if (Error_Level == 0) {
MECOM_SKIP:
		switch_win_id(db_window);
		if (User_id == "") {
			File_Name = Me_Path + truncate_path(file_Name);
		} else {
			File_Name = Me_Path + last_file_Name + '\' + truncate_path(file_Name);
		}

		if (!T_Flag) {
			Return_Str = '%/GENERAL=';
			Call VALIDITY_CHECK;
		}
		Return_Str = 'Processing MECOM configuration data: ' + Old_File_Name;
		Call WRITE_MESSAGE;
		Return_Str = '/SPT=PHONELST.DB/TPT=PHONELST.DB/SW=' + Str(Data_Window) +
					'/TW=' + Str(Db_Window);
		Call REPLACE_HEADER;
		Return_Str = '/SPT=DOWNLOAD.DB/TPT=DOWNLOAD.DB/SW=' + Str(Data_Window) +
					'/TW=' + Str(Db_Window);
		Call REPLACE_HEADER;
		Return_Str = '/SPT=TERMINALS.DB/TPT=TERMINALS.DB/SW=' + Str(Data_Window) +
					'/PL=1/IR=1/TW=' + Str(Db_Window);
		Call REPLACE_HEADER;

		Return_Str = '/HPT=USERMENU.HDR/SPT=COM_USER.MNU/SW=' + Str(Data_Window) +
		 '/TPT=COM_USER.MNU/IR=1/NHR=1/PL=1/TW=' + Str(Db_Window);
		Call REPLACE_HEADER;
		switch_win_id(db_window);
		Call DO_SAVE_FILE;
	}
	RET;

/*
PULL_FROM_MECONFIG:
	Switch_Win_Id(Meconfig_Window);
	Tof;
	if (search_Fwd(t_str,0)) {
		T_Flag = True;
		block_begin;
		eol;
		if (search_fwd('%|12',0)) {
			Up;
		} else {
			eof;
			if (c_col == 1) {
				up;
			}
		}
		Block_End;
		switch_win_id(db_window);
		Eof;
		if (C_Col > 1) {
			down;
		}
		window_move(t_int);
	}
	RET;
*/

MERGE_SPELLSET:
	Error_Level = 0;
	Load_File(File_Name);
	Old_File_Name = File_Name;
	if (Error_Level == 0) {
		Switch_Win_Id(Meconfig_Window);
		Ignore_Case = True;
		Reg_Exp_Stat = True;
		if (Search_Fwd('%|12SPELLSET.ME$',0) == True) {
			RET;
		}
		Return_Str = 'Merging ' + Old_File_Name + ' with main configuration file.';
		Call WRITE_MESSAGE;
		Eof;
		if (C_Col > 1) {
			Down;
		}
		Put_Line('|12SPELLSET.ME');
		Down;
		Call MERGE_TO_MECONFIG;
	}
	RET;

MECONFIG_HEADERS:
	Switch_Win_Id(Meconfig_Window);
	Return_Str = 'Replacing headers in main configuration file: ' + File_Name;
	Call WRITE_MESSAGE;
	Return_Str = '%|12KEYMAC.DB$';
	Call VALIDITY_CHECK;
	if (Return_Int == -1) {
		RET;
	}

// help bookmarks don't exist in version 5
	Return_Str = '/SPT=HELPMARK.DB/TPT=HELPMARK.DB/SW=' + Str(Data_Window) +
				'/PL=1/TW=' + Str(meconfig_Window);
	Call REPLACE_HEADER;

// color templates don't exist in version 5 or 6.0
	Return_Str = '/IR=1/SPT=COLORS.DB/TPT=COLORS.DB/SW=' + Str(Data_Window) +
				'/PL=1/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/SPT=KEYMAC.DB/TPT=KEYMAC.DB/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/IR=1/SPT=KMAPLST.DB/TPT=KMAPLST.DB/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/IR=1/SPT=LANGUAGE.DB/TPT=LANGUAGE.DB/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/IR=1/SPT=EXT.DB/TPT=EXT.DB/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/IR=1/SPT=PGM.DB/TPT=PGM.DB/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/SPT=DEFAULT.PGM/TPT=DEFAULT.PGM/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/PL=1/SPT=USERMENU.HDR/TPT=USERMENU.HDR/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;


	Return_Str = '/SPT=PRN_DEV.DB/TPT=PRN_DEV.DB/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);
	Call REPLACE_HEADER;

	Return_Str = '/EWT=1/NHR=1/HPT=DEFAULT.PGM/PL=1/IR=1/SPT=S.PGM/TPT=S.PGM/SW=' + Str(Data_Window) +
				'/TW=' + Str(Meconfig_Window);

// set_global_int("!@#$%",1);
	Call REPLACE_HEADER;

// RM("CHECK_WINDOWS");

// goto DONT_USE;

	RET;

PRINTERS_HEADERS:
	Return_Str = '%|12NONE.PRT$';
	Call VALIDITY_CHECK;
	if (Return_Int == -1) {
		RET;
	}

	Return_Str = 'Converting print configuration file: ' + File_Name;
	Call WRITE_MESSAGE;
	Return_Str = '/SPT=PRINTERS.DB/TPT=PRINTERS.DB/SW=' + Str(Data_Window) +
			'/TW=' + Str(Db_Window);
	Call REPLACE_HEADER;
	if (Error_Level) {
		RET;
	}

	Return_Str = '/SPT=NONE.PRT/TPT=NONE.PRT/SW=' + Str(Data_Window) +
		'/TW=' + Str(Db_Window);
	Call REPLACE_HEADER;

	RET;

VALIDITY_CHECK:
	Reg_Exp_Stat = True;
	Return_Int = 0;
	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (Search_Fwd(Return_Str,0) == False) {
		Return_Str = 'It appears that the previous version configuration file: ' +
		File_Name + ' is NOT 7.00 compatible.';
		Call ABORT_ROUTINE;
		Return_Int = -1;
	}
	RET;

REPLACE_HEADER:
	RM('REPLACE_HEADER ' + Return_Str);
	Switch_Win_Id(Parse_Int('/TW=',Return_Str));
	if (Return_Int) {
		t_str = return_str;
		call DOUBLE_SLASHES;
		Return_Str = 'Error attempting to replace the header ' +
			Parse_Str('/SPT=',Return_Str) + ' in ' + File_Name +
		 '!  The configuration options related to this may not behave properly. ['
			+ t_str + ']' +

		'/T=REPLACE_HEADER ERROR #' + Str(Return_Int);
		Call ABORT_ROUTINE;
		RET;
	}
	Call DO_SAVE_FILE;
	RET;

DOUBLE_SLASHES:
	t_int = 1;
	while (t_int = xpos("/",t_str,t_int)) {
		t_str = str_ins("/",t_str,++t_int++);
	}
	RET;

MERGE_TO_MECONFIG:
	Switch_Win_Id(Db_Window);
	Tof;
	Block_Begin;
	Eof;
	Block_End;
	T_Int = Cur_Window;
	Switch_Win_Id(Meconfig_Window);
	Window_Copy(T_Int);
	Call DO_SAVE_FILE;
	RET;

CONVERT_KEYMAP:
	Check_Import = True;
	FNF_Ignore = True;
	Call DO_LOAD_FILE;
	if (Error_Level) {
		RET;
	}
	if (convert_mode == 3) {
		goto KEYMAP_HEADER;
	}
/* Change the name of the converted keymap so it will leave originally shipped
keymap intact */
	Return_Str = 'Converting keymap data file: ' + File_Name;
	Call WRITE_MESSAGE;
	File_Name = Get_Path(File_Name) + "CONVK.DB";
	Set_Global_Str('@KEYMAP_NAME@',"KN=CONVERTEDFN=CONVK");
/* Add this new keymap name to the list of keymaps */
	Switch_Win_Id(Meconfig_Window);
	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (search_fwd('%|12KMAPLST.DB$',0)) {
		if (search_fwd('@*@*@*@*START@*@*@*@*',0)) {
			eol;
			insert_mode = true;
			cr;
			put_line("KN=CONVERTEDFN=CONVK");
			Call DO_SAVE_FILE;
		}
	}

	Switch_Win_Id(Db_Window);

	if (No_Import) {
		No_Import_Keymap = True;
		RET;
	}

KEYMAP_HEADER:
/* Replace header in keymap */
	Return_Str = 'Replacing keymap header in: ' + File_Name;
	Call WRITE_MESSAGE;
	Return_Str = '/SPT=KEYMAP.DB/TPT=-1/SW=' + Str(Data_Window) +
				'/TW=' + Str(Db_Window);
	Call REPLACE_HEADER;
	if (convert_mode == 3) {
		RET;
	}

	Switch_Win_Id(Db_Window);
	Return_Str = 'Converting keymap data file: ' + File_Name;
	Call WRITE_MESSAGE;
	RM('CHECK_KEYMAP /DW=' + Str(Data_Window));
	Switch_Win_Id(Db_Window);
	if (Return_Str != '') {
		Return_Str = Return_Str + '  The keymap file: ' + File_Name +
		' may be corrupted.';
		Call ABORT_ROUTINE;
	}
	RET;

CONVERT_INIT:
	t_flag = false;
	Check_Import = True;
	FNF_Ignore = True;
	Call DO_LOAD_FILE;
	if (Error_Level) {
/* If we can't find INIT.S, look for INIT.SRC */
		file_name = truncate_extension(file_name) + ".SRC";
		Check_Import = True;
		FNF_Ignore = True;
		Call DO_LOAD_FILE;
		if (Error_Level) {
			RET;
		}
		t_flag = true;
	}
	if (No_Import) {
		No_Import_Init = True;
		RET;
	}
	Return_Str = 'Converting INIT macro file: ' + File_Name;
	Call WRITE_MESSAGE;
	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (t_flag) {
		t_str = 'Max_Swap_EMS := ';
	} else {
		t_str = 'Max_Swap_EMS = ';
	}

	if (Search_Fwd(t_Str,0)) {
		Set_Global_Int('!ADD_MEM_AMOUNT',0);
		Set_Global_Int('!ADD_MEM_TYPE',1);
		Del_Line;
	}

	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (Search_Fwd('Init_Ems_Support(',0)) {
/* Delete the no longer used Init_Ems_Support */
		Del_Line;
	}

	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = False;
	if (Search_Fwd('#INCLUDE ' + user_id + "KEYMA",0)) {
/* Delete INCLUDE STATEMENT FOR KEYMAP */
		Del_Line;
	}

	Tof;
	if (t_flag) {
		t_str = 'Logo_Screen := ';
	} else {
		t_str = 'Logo_Screen = ';
	}
	if (Search_Fwd(t_str,0)) {
/* Delete the no longer used Logo_Screen */
		Del_Line;
	}
/*
	if (user_id == "") {
		RM("SETUP^SETSERIAL");
	}
*/
	Tof;
	if (Search_Fwd("Set_Global_Str('@@ME_SERIAL#',",0)) {
/* Put new serial number so old one won't overwrite the new one */
		Put_Line('Set_Global_Str(''@ME_SERIAL#'',''' + t_serial + ''');');
	}

	Tof;
	if (t_flag) {
		t_str = 'Swap_Mode := ';
	} else {
		t_str = 'Swap_Mode = ';
	}
	if (Search_Fwd(t_str,0)) {
/* Convert Swap_Mode to its 7.00 equivalent, then get rid of the line */
		Forward_Till("1234567890");
		if (Val(T_Int,Get_Word(';'))) {
			T_Int = 0;
		}
		if (T_Int) {
			if (T_Int > 1) {
				T_Int = 2;
			}
			Swap_Mode = T_Int;
		}
		Del_Line;
	}

	Tof;
	if (t_flag) {
		t_str = 'Init_Video_Mode := ';
	} else {
		t_str = 'Init_Video_Mode = ';
	}
	if (Search_Fwd(t_str,0)) {
/* Convert Init_Video_Mode to its 7.00 equivalent, then get rid of the line */
		Forward_Till("1234567890");
		if (Val(T_Int,Get_Word(';'))) {
			T_Int = 0;
		}
		if (T_Int) {
			if (T_Int > 2) {
				T_Int = 2;
			}
			Init_Video_Mode = T_Int;
		}
		Del_Line;
	}

	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;

/* Compile this converted init file */
	Call DO_SAVE_FILE;
	if (Error_Level) {
		Goto SKIP_INIT_COMPILE;
	}
/* build a command line to compile the macro */
	T_Str = 'MAC.EXE';
	if (t_flag) {
		T_Str = 'ME' + t_str;
	} else {
		T_Str = 'C' + t_str;
	}

// check for proper macro compiler
	if (!file_exists(me_path + t_str)) {
		return_str = "FATAL ERROR:  Cannot find the macro compiler " + me_path +
		t_str;
		if (t_flag) {
			return_str = return_str + ".  Please use MODULE INSTALLATION install.";
		}

		abort_flag = true;
		Call ABORT_ROUTINE;
/*
		RM('MEERROR^MESSAGEBOX /B=2/M=' + Return_Str +
			'/T=CONVERSION ERROR');
		Goto EXIT;
*/
	}

	T_Str = t_str + ' -P' + Me_Path + 'MAC\ ' + File_Name;

/* If the Dos version is 3.0 or above, then add the ME_Path to the compiler
command line to insure the correct version of the macro compiler gets run. */
	if ((Dos_Version & $00FF) > 2) {
/* If the command line would be too long, don't do it. */
		if ((Svl(T_Str) + Length(Me_Path)) < 100) {
			T_Str = ME_PATH + T_Str;
		}
	}


	Del_File(compile_tmp_name);
//	Del_File(user_id + 'SETER.TMP');
	Error_Level = 0;
	Return_str = T_Str;
	RM('MEUTIL1^EXEC /CMDLN=1/SCREEN=3/SWAP=2/MEM=0/RED=' + compile_tmp_name);
//	RM('MEUTIL1^EXEC /CMDLN=1/SCREEN=3/SWAP=2/MEM=0/RED=' + user_id + 'SETER.TMP');
	t_flag = exit_code;

	if (Error_Level != 0) {
INIT_COMPILE_ERROR:
		switch_win_id(db_window);
		if (Error_LEvel == 0) {
			Error_Level = -1;
		}
		Return_Str = 'Error attempting to compile: ' + File_Name + '.';
		Call ABORT_ROUTINE;
		Error_Level = 0;
		Goto SKIP_INIT_COMPILE;
	}
	FNF_Ignore = True;
	Switch_Win_Id(Meconfig_Window);
	File_Name = compile_tmp_name;
//	File_Name = user_id + 'SETER.TMP';
	Call DO_LOAD_FILE;
	if (Error_Level) {
		Goto INIT_COMPILE_ERROR;
	}
	if (t_flag) {
		Goto INIT_COMPILE_ERROR;
	}
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (Search_Fwd('{MEMORY}||{RUNTIME}||{Error}||{Aborted}',0)) {
		Goto INIT_COMPILE_ERROR;
	}
/* We need to reload MECONFIG.DB to prevent SETSAVE from reloading it into a new
window */
 SKIP_INIT_COMPILE:
	Switch_Win_Id(Meconfig_Window);
	Return_Str = 'MECONFIG.DB';
	RM('MAKEUSERPATH');
	File_Name = Return_Str;
	Call DO_LOAD_FILE;
	RM(User_Id + 'INIT');
	Call INIT_PATHS;
	Switch_Win_Id(Db_Window);
	message_color = stat1_color;
/* Come up with defaults for newly added colors if necessary.  These defaults
 * are definately arbitrary and will probably need to be adjusted by the user
 * after the conversion, but at least it is a starting point. */
	Tof;
	if (Search_Fwd('M_K_COLOR',0) == 0) {
/* Menu skip color */
		if (mono) {
/* For mono, same as menu border color except not bright */
			M_K_Color = M_B_Color & $F7;
		} else {
/* For color, use menu border background and grey foreground */
			M_K_Color = (M_B_Color & $F0) | 8;
		}
	}
	Tof;
	if (Search_Fwd('BUTTON_SHADOW_COLOR',0) == 0) {
/* Button shadow color */
		if (mono) {
/* For mono, same as menu border color */
			Button_Shadow_Color = M_B_Color;
		} else {
/* For color, use menu border background and black foreground */
			Button_Shadow_Color = M_B_Color & $F0;
		}
	}
	Tof;
	if (Search_Fwd('W_L_COLOR',0) == 0) {
/* Current line color */
		if (mono) {
/* For mono, same as normal text except bright */
			W_L_Color = W_T_Color | 8;
		} else {
			W_L_Color = 30;
/* For color, use reverse video of normal text color
			W_L_Color = ((W_T_Color & $8) | ((W_T_Color >> 4) & $7)) |
								((W_T_Color & $80) | ((W_T_Color << 4) & $70));
 */
		}
	}
	Tof;
	if (Search_Fwd('W_LB_COLOR',0) == 0) {
/* Current highlited block line color */
		if (mono) {
/* For mono, same as highlited text except underline */
			W_LB_Color = W_H_Color | 1;
		} else {
			W_LB_Color = 110;
/* For color, use reverse video of hilited block color
			W_LB_Color = ((W_H_Color & $8) | ((W_H_Color >> 4) & $7)) |
								((W_H_Color & $80) | ((W_H_Color << 4) & $70));
 */
		}
	}
	RET;

SAVE_INIT:

	RM('SETUP^TGLVID /M=' + str(init_video_mode) );

	Return_Str = Parse_Str('FN=',Global_Str('@KEYMAP_NAME@') + '.DB');
	RM('MAKEUSERPATH /DF=1');
	if (File_Exists(Return_Str)) {
		Set_Global_Int('SETUP_CHANGED',3);
	} else {
//If the keymap db file does not exist, we've got a problem
		return_str = "The keymap data file: " + return_str + " does not exist.";
		abort_flag = true;
		Call ABORT_ROUTINE;
/* we used to do this if the keymap db file did not exist.  I can't think
 of any reason we'd want to do that
		Set_Global_Int('SETUP_CHANGED',1);
*/
	}

/* The function key delay factor was not in <=5.0 and might be annoying to
 old users so set it to 0*/
	if (old_is_5)
		fkey_delay = 0;

/* Persistent blocks configuration was not in <=5.0 and might be very
 annoying to old users so set it to ON */
	if (old_is_5)
		persistent_blocks = 1;

	set_Global_Str('@ME_SERIAL#',t_serial);

/* Run a special version of SETSAVE now to permanently save everything */
	RM('SAVEINIT /NKKW=1');/* /NKKW=1 means don't get rid of keymap window */
	if (Global_Int('SETUP_CHANGED')) {
		return_str = "Error saving configuration.";
		call ABORT_ROUTINE;
	}

	RET;

DO_LOAD_FILE:
	No_Import = False;
	Error_Level = 0;
	Load_File(File_Name);
	if (Error_Level) {
		if (FNF_Ignore) {
			Goto FNF;
		}
LOAD_ERROR:
		Return_Str = 'Error loading the configuration file: ' + File_Name +
				'.  Unpredictable results could occur.';
		Call ABORT_ROUTINE;
		RET;
	}
	Return_Int = 1;
	if ((Convert_Mode != 3) && (Check_Import == True)) {
		Old_File_Name = File_Name;
		T_Str = ME_PATH + Str_Del(File_Name,1,Svl(Old_Path));
		if (Convert_Mode == 2) {
			if (File_Exists(T_Str)) {
CONFIRM_IMPORT:
				Put_Box(9,3,59,16,0,M_B_Color,'7.00 CONVERSION',1);
				Write('The file: ' + Str_Del(T_Str,1,Length(Me_Path)) + ' already exists',10,4,0,M_B_Color);
				Write('in the new version directory.',10,5,0,M_B_Color);
				Write('Ķ',9,6,0,M_B_Color);
				Write('Ķ',9,10,0,M_B_Color);
				Write('If you just installed 7.00, this file is',10,11,0,M_B_Color);
				Write('probably the default file that was installed.',10,12,0,M_B_Color);
				Write('If this is true, you will probably want to',10,13,0,M_B_Color);
				Write('import from the previous version.',10,14,0,M_B_Color);

				RM('USERIN^XMENU /X=10/Y=7/B=0/T=1/M=' +
						'Import and convert data from previous version()' +
						'Don''t import this file from previous version()' +
						'Abort conversion completely()');
				Kill_Box;
				if (Return_Int == 1) {
				} else if (Return_Int == 2) {
					Error_Level = 0;
					File_Name = T_Str;
					Load_File(File_Name);
					if (Error_Level) {
						Goto LOAD_ERROR;
					}
					No_Import = True;
					Goto FILE_LOADED;
				} else if (Return_Int == 3) {
					Goto PROMPT_ABORT;
				} else {
					Goto CONFIRM_IMPORT;
				}

			}
		}
		File_Name = T_Str;
	}

FILE_LOADED:
	Read_Only = False;
	Cur_File_Attr = Cur_File_Attr & $FE;
FNF:
	Check_Import = False;
	FNF_Ignore = False;
	RET;

DO_SAVE_FILE: {
	int t_backups = backups;
	str t_backup_path[80] = backup_path,
			t_temp_path[80] = temp_path;

		Backups = 1;
		Backup_Path = "";
		Temp_Path = "";

	Error_Level = 0;
	Save_File;
	Backups = t_backups;
	Backup_Path = t_backup_path;
	Temp_Path = t_temp_path;
	if (Error_Level) {
		Return_Str = 'Error ' + str(error_level) + ' saving the file: ' + File_Name +
				'.  Unpredictable results could occur.';
		Call ABORT_ROUTINE;
	}
	RET;
}

WRITE_MESSAGE:
	if (Box_Count > T_Box_Count) {
		Kill_Box;
	}
	RM('MEERROR^MESSAGEBOX /NW=1/T=7.00 CONVERSION/M=' + Return_Str);
	RET;

INIT_PATHS:
	Set_Global_Str('~TEMP_PATH', temp_path );
	temp_path = "";
	Set_Global_Str('~BACKUP_PATH', backup_path );
	backup_path = "";
	if (mouse) {
		Set_Global_Str("@MOUSEPARMS","/M=1" + Global_Str("@MOUSEPARMS"));
	}
	RET;

ABORT_ROUTINE:
	if (abort_flag)
		return_str = return_str +
			'/T=FATAL CONVERSION ERROR';
	else
		return_str = return_str +
			'  Press <ESC> to abort the conversion, or any other key to continue.' +
			'/T=CONVERSION ERROR';

	RM('MEERROR^MESSAGEBOX /B=2/M=' + Return_Str);

	if (abort_flag)
		goto EXIT;

	if (Key1 == 27)
		Goto PROMPT_ABORT;

	refresh = false;
	RET;


EXIT:

	if (Switch_Win_Id(Db_Window)) {
		Delete_Window;
	}
	if (Switch_Win_Id(Data_Window)) {
		Delete_Window;
	}
	if (Switch_Win_Id(Meconfig_Window)) {
		Delete_Window;
	}
	Switch_Win_Id(Active_Window);

/*
DONT_USE:
RM("MEERROR^MESSAGEBOX /B=4/T=NOT READY FOR RELEASE/M=You've got debugging code in this macro, dude!");
IF (Switch_Win_Id(Db_Window)) {
File_Changed = False;
}
IF (Switch_Win_Id(Data_Window)) {
File_Changed = False;
}
IF (Switch_Win_Id(Meconfig_Window)) {
File_Changed = False;
}
T_Int = 0;
WHILE (T_Int < Window_Count) {
++T_INt;
Switch_Window(T_Int);
Window_Attr = 0;
}
*/

	File_Search_Attr = T_File_Search_Attr;
	File_Search_Rec = T_File_Search_Rec;
	Undo_Stat = T_Undo_Stat;
	Insert_Mode = T_Insert_Mode;
	while (Box_Count > T_Box_Count) {
		Kill_Box;
	}
	User_Id = T_User_Id;
	RM(User_Id + 'INIT');
	Error_Level = 0;

/*
make_message("Before=" + str(what) + " After=" + str(window_count));
*/
}
/*

macro CHECK_WINDOWS {
	int active_window = window_id,
		t_refresh = refresh;

again:
	window_attr = 0;
	refresh = true;
	redraw;
	make_message("This is window " + str(cur_window) + " of " + str(window_count));
	read_key;
	if (key1 != 27) {
		if (key1 == 0) {
			pass_key(key1,key2);
		} else {
			switch_window(cur_window + 1);
		}
		goto again;
	}


EXIT:
	switch_win_id(active_window);
	refresh = t_refresh;
}
*/

macro SAVEINIT TRANS2 {
/*******************************************************************************
															 MULTI-EDIT MACRO

NAME:  special version of SETSAVE for CONV_700

DESCRIPTION:  This macro creates and compiles INIT.S to save all setup
							parameters

PARAMETERS:
							/NKKW=1		Don't get rid of keymap window when done.  This
												rarely used parameter was created specifically
												for conversion macros so that the keymap window
												can be retained and reused.

							 (C) Copyright 1991 by American Cybernetics, Inc.
*******************************************************************************/

/*
Global Variables used:
Global_Int('Init_Window')  The window where INIT.S is created.
Plus a myriad of globals that get used to create INIT.S... much to numerous
to be practical to mention here.
 */
	str
					Whole_Line,
					F_Label[20],
					TStr,
					Temp_Stuff,
					Extension[80],
					Temp_Global,
					Program,
					compile_tmp_name[120]
					;

	int tid,Temp_Integer,Jx,Jy,T_Tab_Expand,T_Reg_Exp_Stat,Global_Count,
					P_Jx,P_Jy,T_Insert_Mode,
					t_backups = backups;
	int Active_Window,Keymap_Window,Macro_Window,Error_Window,
					Cmd, bc;
	str MStr,MName[30],KName[17],Mode_Str[10];

// Mod to handle correct placement of .TMP files
	RM("TMP_FILE_NAME /FN=SETER.TMP");
	compile_tmp_name = return_str;
/* Initialize variables and save some system variables into temporary variables */
	if(  (Global_Str('@KEYMAP_NAME@') == '')  ) {
		Set_Global_Str('@KEYMAP_NAME@','KN=MULTI-EDITFN=KEYMAP');
	}

	backups = 1;

	T_Reg_Exp_Stat = Reg_Exp_Stat;
	T_Insert_Mode = Insert_Mode;
	Return_Str = '';
	Undo_Stat = False;
	T_Tab_Expand = Tab_Expand;
	Tab_Expand = False;
	Insert_Mode = True;
	Active_Window = Window_Id;
	Switch_Window(Window_Count);
	Create_Window;
	Macro_Window = Window_Id;
	Refresh = False;

	if(  (Global_Int('SETUP_CHANGED') & $02)  ) {

		Reg_Exp_Stat = False;
		RM('MEERROR^MessageBox /B=0/NW=1/T=SAVING CONFIGURATION/M=Building Keymap macro...');
	/* 	Make_Message('Building Keymap macro...');  */
		Return_Str = Parse_Str('FN=',Global_Str('@KEYMAP_NAME@'));
		if(  (Global_Str('@DB_EXTENSION') == '')  ) {
			Return_Str = Return_Str + '.DB';
		} else {
			Return_Str = Return_Str + '.' + Global_Str('@DB_EXTENSION');
		}
		RM('MakeUserPath /DF=1');
		if(  (Switch_File(Return_Str) == 0)  ) {
			Switch_Window(Window_Count);
			Create_Window;
			Error_Level = 0;
			Load_File(Return_str);
			if(  (Error_Level)  ) {
				RM('MEERROR^MESSAGEBOX /B=2/T=ERROR ' + Str(Error_Level) + '/M=Can''t find ' + Return_Str +
						'.  Install terminated.');
				Error_Level = 0;
				Goto END_OF_MAC;
			}
		} else {
			Tof;
			if(  (File_Changed)  ) {
				Error_Level = 0;
				Save_File;
				if(  (Error_Level)  ) {
					RM('MEERROR^MESSAGEBOX /B=2/T=ERROR ' + Str(Error_Level) + '/M=Can''t save ' + Return_Str +
							'.  Install terminated.');
					Error_Level = 0;
					Goto END_OF_MAC;
				}
			}
		}

		Keymap_Window = Window_Id;
		Switch_Win_Id(Macro_Window);
		Return_Str = User_Id + 'KEYMAP.S';
		RM('MakeUserPath');
		File_Name = Return_Str;
		PUT_LINE('macro ' + USER_ID + 'KEYMAP DUMP {');
		Insert_Mode = True;
		Down;
		Put_Line('// This macro was created by the Multi-Edit install macro version ' + Version );
		Down;
		Down;
		Put_Line('// Default key assignments');
		Down;
		Switch_Win_Id(Keymap_Window);

  	if(  (Search_Fwd('****START****',0))  ) {
			Down;
			Goto_Col(1);
		}
		while(  (Not(At_Eof))  ) {
			TStr = Get_Line;
			Down;
			MName = Parse_Str('MC=',TStr);
			if(  (Mname != '')  ) {
				if(  (Switch_Win_Id(Macro_Window))  ) {
					mstr = Parse_Str('MID=', tstr );
					if(  mstr != ''  ) {
						set_global_str( mstr, '' );
					}
					KName = Parse_Str('K1=',Tstr);
					if(  (KName != '')  ) {
						Call Build_Key_Line;
						mstr = Parse_Str('MID=', tstr );
						if(  mstr != ''  ) {
							put_line('Set_Global_Str(''' + mstr + ''', ''' + kname + ''');');
							DOWN;
						}
					}
					KName = Parse_Str('K2=',Tstr);
					if(  (KName != '')  ) {
						Call Build_Key_Line;
					}

					Switch_Win_Id(Keymap_Window);
				}
			}
		}
		Switch_Win_Id(Macro_Window);
		Down;
		PUT_LINE('}');

		Save_File;
		Kill_Box;
/*
		Call COMPILE;
		if(  (Return_Int)  ) {
			Return_Str = 'COMP ERROR';
			Goto END_OF_MAC;
		} else {
*/
			if(  (Switch_Win_Id(Keymap_Window))  ) {
				if(  (Parse_Int('/NKKW=',MParm_Str) == 0)  ) {
					Delete_Window;
				}
			}
			Switch_Win_Id(Active_Window);
/*
		}
*/
	}

/* Create INIT.S */
	RM('MEERROR^MessageBox /B=0/NW=1/T=SAVING CONFIGURATION/M=Building "' + user_id + 'INIT.S"...');
	Switch_Win_Id(Macro_Window);
	Erase_Window;
	Undo_Stat = false;
	Return_Str = User_Id + 'INIT.S';
	RM('MakeUserPath');
	File_Name = Return_Str;
	Set_Global_Int('Init_Window',Window_Id);
/* Create the start of a macro source code */
	PUT_LINE('macro ' + USER_ID + 'INIT DUMP {');
	Insert_Mode = True;
	Down;
	Put_Line('// This macro was created by the Multi-Edit install macro version ' + Version );
	Down;
	Down;
	Eol;
	Cr;
	Cr;
	Up;
	Up;

/* the Expanded memory settings need to come first */
	if(  global_int('!ADD_MEM_TYPE') != 0  ) {
		Put_Line('Init_Additional_Mem(' + Str(Global_Int('!ADD_MEM_AMOUNT')) + ', ' +
							Str(Global_Int('!ADD_MEM_TYPE')) + ');');
		Down;
		Put_Line('Set_Global_Int(''!ADD_MEM_AMOUNT'',' + Str(Global_Int('!ADD_MEM_AMOUNT')) + ');');
		Down;
		Put_Line('Set_Global_Int(''!ADD_MEM_TYPE'',' + Str(Global_Int('!ADD_MEM_TYPE')) + ');');
		Down;
	}
	Put_Line('Swap_Mode = ' + Str( swap_mode ) + ';');
	Down;
	Put_Line('Swap_Mem = ' + Str( Swap_Mem ) + ';');
	Down;

	/* Make_Message('Building "' + user_id + 'INIT.S"...'); */
	Working;


/* Create all the other settings, most are self explanitory */
	Down;
	Down;
	Put_Line('ERROR_LEVEL = 0;'); Down;
	RM('USERIN^STRSRC ' + Global_Str('@KEYMAP_NAME@'));
	Put_Line('Set_Global_Str(''@KEYMAP_NAME@'',''' + Return_Str + ''');');
	Down;
	Put_Line('RM(''' + User_Id + 'KEYMAP'');'); Down;
	Put_Line('if (ERROR_LEVEL != 0)'); Down;
	Put_Line('  RM(''KEYMAP'');'); Down;
	Put_Line('Set_Global_Str(''@ME_SERIAL#'',''' + Global_Str('@ME_SERIAL#') + ''');');
	Down;
	Put_Line('// Default settings');
	Down;
	Put_Line('Set_Global_Int(''Default_Insert_Mode'',' + Str(Global_Int('Default_Insert_Mode')) + ');');
	Down;
	Put_Line('Set_Global_Int(''SEARCH_INTR_STYLE'',' + Str(Global_Int('SEARCH_INTR_STYLE')) + ');');
	Down;
	Put_Line('Set_Global_Str(''SWITCHES'',''' + Global_Str('DEF_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''DEF_SWITCHES'',''' + Global_Str('DEF_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''REPL_SWITCHES'',''' + Global_Str('DEF_REPL_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''DEF_REPL_SWITCHES'',''' + Global_Str('DEF_REPL_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''FSWITCHES'',''' + Global_Str('DEF_FS_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''DEF_FS_SWITCHES'',''' + Global_Str('DEF_FS_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''FSEARCH_PATH'',''' + Global_Str('DEF_FS_PATH') + ''');');
	Down;
	Put_Line('Set_Global_Str(''DEF_FS_PATH'',''' + Global_Str('DEF_FS_PATH') + ''');');
	Down;
	Put_Line('Set_Global_Str(''FRSWITCHES'',''' + Global_Str('DEF_FSR_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''DEF_FSR_SWITCHES'',''' + Global_Str('DEF_FSR_SWITCHES') + ''');');
	Down;
	Put_Line('Set_Global_Str(''FSEARCH_REPL_PATH'',''' + Global_Str('DEF_FSR_PATH') + ''');');
	Down;
	Put_Line('Set_Global_Str(''DEF_FSR_PATH'',''' + Global_Str('DEF_FSR_PATH') + ''');');
	Down;
	Put_Line('Insert_Mode = Global_Int(''Default_Insert_Mode'');');
	Down;
	Put_Line('Explosions = ' + Str(Explosions) + ';');
	Down;
	Put_Line('FKey_Delay = ' + Str(fkey_delay) + ';');
	Down;
	Put_Line('Backups = ' + Str(T_Backups) + ';');
	Down;
	Put_Line('Backup_Path = ''' + Global_Str('~Backup_Path') + ''';');
	Down;
	Put_Line('Temp_Path = ''' + Global_Str('~Temp_Path') + ''';');
	Down;
/* see the macro STRSRC in this same macro file for an explanation */
	RM('USERIN^STRSRC ' + Page_Str );
	Put_Line('Page_Str = ''' + Return_Str + ''';');
	Down;
	Put_Line('Truncate_Spaces = ' + Str(Truncate_Spaces) + ';');
	Down;
	Put_Line('Set_Global_Str(''!AUTOSAVEPARMS'',''' + Global_Str('!AUTOSAVEPARMS') + ''');');
	Down;
	Put_Line('Set_Global_Int(''@DIALOG_STYLE'',' + Str(Global_Int('@DIALOG_STYLE')) + ');');
	Down;
	if(  (GLOBAL_INT('@DIALOG_STYLE') == 1)  ) {   /* set globals for help system */
		Put_Line('Set_Global_Str(''!ACCEPT_LABEL'',''OK<ENTER>'');');
		Down;
		Put_Line('Set_Global_Str(''!ACCEPT_KEY'',''<ENTER>'');');
		Down;
		Put_Line('Set_Global_Str(''!NEXT_KEY'',''<TAB>'');');
		Down;
		Put_Line('Set_Global_Str(''!PREV_KEY'',''<ShftTAB>'');');
		Down;
		Put_Line('Set_Global_Str(''!HISTORY_KEY'',''<>'');');
		Down;
		Put_Line('Set_Global_Str(''!GROUP_KEY'',''<>'');');
		Down;
	} else {
		Put_Line('Set_Global_Str(''!ACCEPT_LABEL'',''  OK<F10>'');');
		Down;
		Put_Line('Set_Global_Str(''!ACCEPT_KEY'',''<F10>'');');
		Down;
		Put_Line('Set_Global_Str(''!NEXT_KEY'',''<>'');');
		Down;
		Put_Line('Set_Global_Str(''!PREV_KEY'',''<>'');');
		Down;
		Put_Line('Set_Global_Str(''!HISTORY_KEY'',''<F4>'');');
		Down;
		Put_Line('Set_Global_Str(''!GROUP_KEY'',''<|26>'');');
		Down;
	}
	Put_Line('Set_Global_Int(''DIR_IMMEDIATE'',' + Str(Global_Int('DIR_IMMEDIATE')) + ');');
	Down;
	Put_Line('Set_Global_Int(''AUTO_ARRANGE_ICONS'',' + Str(Global_Int('AUTO_ARRANGE_ICONS')) + ');');
	Down;
	Put_Line('Set_Global_Int(''NO_CONFIRM_OVERWRITE'',' + Str(Global_Int('NO_CONFIRM_OVERWRITE')) + ');');
	Down;
	Put_Line('Set_Global_Int(''@PGM_MENU_BYPASS'',' + Str(Global_Int('@PGM_MENU_BYPASS')) + ');');
	Down;
	Put_Line('Set_Global_Int(''@WILDCARD_MODE'',' + Str(Global_Int('@WILDCARD_MODE')) + ');');
	Down;


	Put_Line('persistent_Blocks = ' + Str(persistent_Blocks) + ';');
	Down;
/* AN INTENTIONAL SYNTAX ERROR TO TEST ERROR HANDLING.
PUT_LINE('PERSTENT_BLOCKS = ' + STR(PERSISTENT_BLOCKS) + ';');
DOWN;
*/
	Put_Line('Ctrl_Help = ' + Str(Ctrl_Help) + ';');
	Down;
	Put_Line('Ctrl_Z = ' + Str(Ctrl_Z) + ';');
	Down;
	Put_Line('Eof_Cr = ' + Str(Eof_Cr) + ';');
	Down;
	Put_Line('File_Locking = ' + Str(File_Locking) + ';');
	Down;
	Put_Line('Display_Tabs = ' + Str(Display_Tabs) + ';');
	Down;
	Put_Line('Tab_Expand = ' + Str(T_Tab_Expand) + ';');
	Down;
	Put_Line('Mouse_H_Sense = ' + Str(Mouse_H_Sense) + ';');
	Down;
	Put_Line('Mouse_V_Sense = ' + Str(Mouse_V_Sense) + ';');
	Down;
	Put_Line('Set_Global_Int( ''~INIT_MOUSE'',' + str(parse_int('/M=', global_str('@MOUSEPARMS'))) + ');');
	Down;
	Put_Line('Mou_Disappear = ' + Str(Mou_Disappear) + ';');
	Down;
	Put_Line('Set_Global_Str(''@MOUSEPARMS'',''' + global_str('@MOUSEPARMS') + ''');');
	down;
	RM('USERIN^STRSRC ' + Word_Delimits );
	Put_Line('Word_Delimits = ''' + Return_Str + ''';');
	Down;
	Put_Line('Ins_Cursor = ' + Str(Ins_Cursor) + ';');
	Down;
	Put_Line('Ovr_Cursor = ' + Str(Ovr_Cursor) + ';');
	Down;
	Put_Line('Max_Undo = ' + Str(Max_Undo) + ';');
	Down;
	Put_Line('Column_Move_Style = ' + Str(Column_Move_Style) + ';');
	Down;
	Put_Line('Set_Global_Str(''FORMAT_CODE_DELIMIT'',''' + Global_Str('FORMAT_CODE_DELIMIT') + ''');');
	Down;
	Put_Line('Set_Global_Str(''PRINTER_DEVICE'',''' + Global_Str('PRINTER_DEVICE') + ''');');
	Down;
	Put_Line('Set_Global_Str(''PRINTER_TYPE'', ''' + Global_Str('PRINTER_TYPE') + ''');');
	Down;
	Put_Line('Print_Margin = ' + Str(Print_Margin) + ';');
	Down;

	Put_Line('Set_Global_Int(''RESTORE'',' + Str(Global_Int('RESTORE')) + ');');
	Down;
 /* The following 16 lines are for the screen configuration for status lines
 function key lines, file name lines, etc. */
	Put_Line('Set_Global_Str(''@SCREEN_SETA'',''' + Global_STR('@SCREEN_SETA') + ''');');
	Down;
	Put_Line('Set_Global_Str(''@SCREEN_SETB'',''' + Global_STR('@SCREEN_SETB') + ''');');
	Down;
	Put_Line('Set_Global_Int(''DEF_SCRN_STYLE'',' + Str(Global_Int('DEF_SCRN_STYLE')) + ');');
	Down;
	Put_Line('Set_Global_Int(''CUR_SCRN'',' + Str(Global_Int('DEF_SCRN_STYLE')) + ');');
	Down;
	Put_Line('Set_Global_Int(''SPLIT_EDGE_MODE'',' + Str(Global_Int('SPLIT_EDGE_MODE')) + ');');
	Down;
	Put_Line('Set_Global_Int(''!AutoArrangErrSrc'',' + Str(Global_Int('!AutoArrangErrSrc')) + ');');
	Down;

	Put_Line('Init_Video_Mode = ' + Str(Video_Mode) + ';');
	Down;
	Put_Line('Ext_Video_Mode = ' + Str(Ext_Video_Mode) + ';');
	Down;

	Put_Line('Error_Color = ' + Str(Error_Color) + ';');
	Down;
	Put_Line('Shadow_Color = ' + Str(Shadow_Color) + ';');
	Down;
	Put_Line('Shadow_Char = ''||' + str(ascii(Shadow_Char)) + ''';');
	Down;
	Put_Line('W_T_Color = ' + Str(w_t_color) + ';');
	Down;
	Put_Line('W_H_Color = ' + Str(w_h_color) + ';');
	Down;
	Put_Line('W_B_Color = ' + Str(w_b_color) + ';');
	Down;
	Put_Line('W_C_Color = ' + Str(w_c_color) + ';');
	Down;
	Put_Line('W_L_Color = ' + Str(w_l_color) + ';');
	Down;
	Put_Line('W_LB_Color = ' + Str(w_lb_color) + ';');
	Down;
	Put_Line('W_EOF_Color = ' + Str(w_EOF_color) + ';');
	Down;
	Put_Line('W_S_Color = ' + Str(w_s_color) + ';');
	Down;
	Put_Line('M_T_Color = ' + Str(m_t_color) + ';');
	Down;
	Put_Line('M_S_Color = ' + Str(m_s_color) + ';');
	Down;
	Put_Line('M_K_Color = ' + Str(m_k_color) + ';');
	Down;
	Put_Line('M_B_Color = ' + Str(m_b_color) + ';');
	Down;
	Put_Line('M_H_Color = ' + Str(m_h_color) + ';');
	Down;
	Put_Line('CB_H_Color = ' + Str(cb_h_color) + ';');
	Down;
	Put_Line('CB_T_Color = ' + Str(cb_t_color) + ';');
	Down;
	Put_Line('CB_S_Color = ' + Str(cb_s_color) + ';');
	Down;
	Put_Line('Button_Color = ' + Str(button_color) + ';');
	Down;
	Put_Line('Button_Key_Color = ' + Str(button_key_color) + ';');
	Down;
	Put_Line('Button_Shadow_Color = ' + Str(button_shadow_color) + ';');
	Down;
	Put_Line('D_T_Color = ' + Str(d_t_color) + ';');
	Down;
	Put_Line('D_S_Color = ' + Str(d_s_color) + ';');
	Down;
	Put_Line('D_B_Color = ' + Str(d_b_color) + ';');
	Down;
	Put_Line('D_H_Color = ' + Str(d_h_color) + ';');
	Down;
	Put_Line('H_T_Color = ' + Str(h_t_color) + ';');
	Down;
	Put_Line('H_T1_Color = ' + Str(h_t1_color) + ';');
	Down;
	Put_Line('H_T2_Color = ' + Str(h_t2_color) + ';');
	Down;
	Put_Line('H_T3_Color = ' + Str(h_t3_color) + ';');
	Down;
	Put_Line('H_S_Color = ' + Str(h_s_color) + ';');
	Down;
	Put_Line('H_B_Color = ' + Str(h_b_color) + ';');
	Down;
	Put_Line('H_H_Color = ' + Str(h_h_color) + ';');
	Down;
	Put_Line('H_R_Color = ' + Str(h_r_color) + ';');
	Down;
	Put_Line('H_F_Color = ' + Str(h_f_color) + ';');
	Down;
	Put_Line('FKey_Color = ' + Str(fkey_color) + ';');
	Down;
	Put_Line('FNum_Color = ' + Str(fnum_color) + ';');
	Down;
	Put_Line('Stat1_Color = ' + Str(stat1_color) + ';');
	Down;
	Put_Line('Stat2_Color = ' + Str(stat2_color) + ';');
	Down;
	Put_Line('Message_Color = ' + Str(message_color) + ';');
	Down;
	Put_Line('Working_Color = ' + Str(working_color) + ';');
	Down;
	Put_Line('Background_Color = ' + Str(background_color) + ';');
	Down;
	Put_Line('Set_Global_Str(''@SYNTAX_COLORS'',''' + Global_Str('@SYNTAX_COLORS') + ''');');
	Down;
	Put_Line('Keyword_Highlighting = ' + Str(Keyword_Highlighting) + ';');
	Down;
	Put_Line('Keyword_Cline_Override = ' + Str(Keyword_Cline_Override) + ';');
	Down;

/* Dos shell stuff */
	Put_Line('Set_Global_Str(''DIR_SORT_STR'',''' + Global_Str('DIR_SORT_STR') + ''');');
	Down;
	Put_Line('Set_Global_Int(''@DIR_MODE@'',' + Str(Global_Int('@DIR_MODE@')) + ');');
	Down;
/* Condensed mode globals */
/*
	Put_Line('Set_Global_Int(''CONDENSE_MODE'',' + Str(Global_Int('CONDENSE_MODE')) + ');');
	Down;
	Put_Line('Set_Global_Int(''CUTOFF_COL'',' + Str(Global_Int('CUTOFF_COL')) + ');');
	Down;
	RM('USERIN^STRSRC ' + Global_Str('CONDENSE_SEARCH'));
	Put_Line('Set_Global_Str(''CONDENSE_SEARCH'',''' + Return_Str + ''');');
	Down;
	Put_Line('Set_Global_Str(''CONDENSE_SWITCHES'',''' + Global_Str('CONDENSE_SWITCHES') + ''');');
	Down;
 */
/* Calculator Parameters */
	Temp_Stuff = '/X=' + Parse_Str('/X=',Global_Str('Calc_Params')) +
		'/Y=' + Parse_Str('/Y=',Global_Str('Calc_Params')) +
		'/BASE=' + Parse_Str('/BASE=',Global_Str('Calc_Params'));
	Put_Line('Set_Global_Str(''CALC_PARAMS'',''' + Temp_Stuff + ''');');
	Down;

/* The following are in conjuction with the keyboard key repeat(typematic) speed
setup macro which uses the new interrupt procedure */
	Put_Line('Set_Global_Int(''KEYSPEED'',' + Str(Global_Int('KEYSPEED')) + ');');
	Down;
	Put_Line('Set_Global_Int(''KEYDELAY'',' + Str(Global_Int('KEYDELAY')) + ');');
	Down;
	Put_Line('Set_Global_Int(''NO_KEYSPEED'',' + str( global_int('NO_KEYSPEED') ) + ');');
	Down;
	Put_Line('Set_Global_Str(''@DEFAULT_EXT_LIST'',''' + Global_Str('@DEFAULT_EXT_LIST') + ''');');
/* Put ending line */
	Down;
	PUT_LINE('}');
	Down;
	PUT_LINE("#INCLUDE " + user_id + "KEYMAP");
	Tab_Expand = True;
	Save_File;

	Call COMPILE;
	if(  (Return_Int == 0)  ) {
/*		copy_file( me_path + 'MAC\' + user_id + 'KEYMAP.MAC',
									me_path + 'MAC\' + user_id + 'INIT.MAC',
									TRUE );
*/
	 /* Make_Message( 'Multi-Edit configuration saved.'); */
		Set_Global_Int('SETUP_CHANGED',0);

/* This is to clear out all existing function key labels in edit mode. */
		Jx = 4;
		while(  (Jx)  ) {
			--Jx;
			Jy = 10;
			while(  (Jy)  ) {
				Flabel('',(Jx * 10) + Jy,0);
				--Jy;
			}
		}

		RM( user_id + 'INIT' );
/* Need to reload the keystroke macros in case the keymapping overwrote something */
		RM('KEYMAC_LOAD /NE=1');
		Error_Level = 0;
		Del_File(compile_tmp_name);
//		Del_File(user_id + 'SETER.TMP');
		Error_Level = 0;
	} else {
	 /* Make_Message( 'Error occurred!! Configuration NOT saved.');  */
		Return_Str = 'COMP ERROR';
	}

	Goto END_OF_MAC;
/*********************************** SUBROUTINES *******************************/
	BUILD_KEY_LINE:
		Jx = Parse_Int('MODE=',Tstr);
		if(  ((Jx < 1) | (Jx > 4))  ) {
			Jx = 1;
		}
		Mode_Str = Remove_Space(Copy('EDIT     DOS_SHELLTERM     ALL',
			((Jx - 1) * 9) + 1, 9));
    if (  parse_int('EDBOX=', tstr) )
    {
      mode_str += "|0x80";
    }
		Cmd = (Parse_Str('MF=',TStr) == 'NOT APPLICABLE');
		if(  (Cmd)  ) {
			MStr = 'CMD_TO_KEY(';
		} else {
			MStr = 'MACRO_TO_KEY(';
		}
		MStr = MStr + KName + ',';
		if(  (Cmd == False)  ) {
			MStr = MStr + '''';
			if(  Parse_Str('MF=',Tstr) != ''  ) {
				mstr = mstr + Parse_Str('MF=',Tstr) + '^';
			}
		}
		MStr = MStr + MName;
		if(  (Cmd == False)  ) {
			MStr = MStr + ' ' + Parse_Str('PARAM=',TSTr) + '''';
		}
		Jx = Parse_Int('',Tstr);
		if(  ((Jx < 1) | (Jx > 4))  ) {
			Jx = 1;
		}
		MStr = MStr + ',' + Mode_Str + ');';
		Put_Line(MStr);
		Down;
		if(  (Parse_Str('FKL=',TStr) != '')  ) {
	/* See if this key is a function key */

			MStr = Parse_Str('F',KName);;
			if(  (MStr != '')  ) {
				while(  (XPos(Copy(Mstr,Svl(MStr),1),'0123456789',1) == 0)  ) {
					MStr = Copy(MStr,1,Svl(MStr) - 1);
					if(  (Mstr == '')  ) {
						Goto NO_LABEL;
					}
				}
				if(  (MStr != '')  ) {
					if(  (Val(jx,Mstr) == 0)  ) {
						if( (jx < 13 ) && (jx > 0) ) {
							if( !Xpos( 'CTRLSHFT', caps(kname), 1 ) &&
									!Xpos( 'ALTSHFT', caps(kname), 1 ) ) {
								if(  (XPos('SHFT',Caps(KName),1))  ) {
									if( jx > 10 )
											jx = (jx - 10) + 42;
									else
										Jx = Jx + 10;
								}
								else if(  (XPos('CTRL',Caps(KName),1))  ) {
									if( jx > 10 )
											jx = (jx - 10) + 44;
									else
										Jx = Jx + 20;
								}
								else if(  (XPos('ALT',Caps(KName),1))  ) {
									if( jx > 10 )
											jx = (jx - 10) + 46;
									else
										Jx = Jx + 30;
								}
								else {
									if( jx > 10 )
											jx = (jx - 10) + 40;
								}

								Put_Line('FLABEL(''' + Parse_Str('FKL=',TStr) + ''',' + Str(Jx) +
									',' + Mode_Str + ');');
								Down;
							}
						}
					}
				}
			}
		}
	NO_LABEL:
	RET;

COMPILE:
	Reg_Exp_Stat = True;
	Return_Int = 0;
	TStr = Truncate_Path(File_Name);
	Kill_Box;
	RM('MEERROR^MessageBox /B=0/NW=1/T=SAVING CONFIGURATION/M=Compiling "'+ TStr +'"...');
 /* Make_Message('Compiling "'+ TStr +'"...'); */
/* build a command line to compile the macro */
	Whole_Line = 'CMAC.EXE -P' + Me_Path + 'MAC\' +' ' + File_Name;
/* If the Dos version is 3.0 or above, then add the ME_Path to the compiler
command line to insure the correct version of the macro compiler gets run. */
	if(  ((Dos_Version & $00FF) > 2)  ) {
/* If the command line would be too long, don't do it. */
		if(  ((Svl(Whole_Line) + Length(Me_Path)) < 100)  ) {
			Whole_Line = ME_PATH + Whole_Line;
		}
	}

	Del_File(compile_tmp_name);
//	Del_File(user_id + 'SETER.TMP');
	Error_Level = 0;
	Return_str = whole_line;
	RM('MEUTIL1^EXEC /CMDLN=1/SCREEN=3/SWAP=2/MEM=0/RED=' + compile_tmp_name);
//	RM('MEUTIL1^EXEC /CMDLN=1/SCREEN=3/SWAP=2/MEM=0/RED=' + user_id + 'SETER.TMP');
	kill_box;
	if(  (Error_Level != 0)  ) {
			RM('MEERROR^Beeps /C=1');
/* Error messages for unsuccessful compile */
		if(  (Error_Level == 3008)  ) {
	NO_MEMORY_ERROR:
			rm('MEERROR^MessageBox /T=INSUFFICIENT MEMORY TO COMPILE ' + TStr +
					'!/B=2/M=Please exit editor and compile ' + TStr + ' in the Multi-Edit directory.');
			Error_Level = 0;
			Return_Int = 1;
			RET;
		}
		RM( 'MEERROR' );
		Return_Int = 1;
		RET;
	}
	return_str = '';
	return_int = 0;
	if(  exit_code != 0  ) {
		Switch_Window(Window_Count);
		Create_Window;
		Error_Window = Window_Id;
		Load_File(compile_tmp_name);
//		Load_File(user_id + 'SETER.TMP');
		if(  (Error_Level == 3002)  ) {
				RM('MEERROR^Beeps /C=1');
				RM('MEERROR^MessageBox /T=ERROR IN COMPILING ' + TStr +
					'!/B=2/M=Check for proper path to macro compiler.');
				Error_Level = 0;
				Return_Int = 1;
				goto BAD_COMPILE;
		}
		Ignore_case = True;
		if(  (Search_Fwd('{MEMORY}||{RUNTIME}',0))  ) {
			Goto No_Memory_Error;
		}
		Tof;
		if(  (Search_Fwd('{Error}||{Aborted}',0))  ) {
			RM('MEERROR^Beeps /C=1');
			RM('MEERROR^MessageBox /T=ERROR IN COMPILING ' + TStr +
						'!/B=2/M=' + Copy(Get_Line,1,76));
			Refresh = True;
			Kill_Box;
			Kill_box;
			New_Screen;
			Messages = True;
			Undo_Stat = True;
			Return_Int = 1;
			Goto BAD_COMPILE;
		}
		TOF;
		if(  (Search_Fwd(shorten_str(Version),1) == 0)  ) {
	/* we should only get here if somehow a different version of the macro compiler
	was run than the version of ME.  A distinct possiblilty if multiple versions
	of ME are on the system. */
			RM('MEERROR^MESSAGEBOX /B=2/T=WARNING:  MACRO COMPILER REPORTS WRONG VERSION' +
						'/M=Unpredictable results could occur.  Check DOS environment for possible incorrect search path.');
			/* Make_Message(''); */
			Kill_Box;
			Kill_box;
			New_Screen;
			Messages = True;
			Undo_Stat = True;
			Return_Str = 'COMP WARNING';
		}
BAD_COMPILE:
		if(  (Switch_Win_Id(Error_Window))  ) {
			Delete_Window;
		}
	}
	if(  return_str != 'COMP WARNING'  ) {
		Del_File(compile_tmp_name);
//		Del_File(user_id + 'SETER.TMP');
	}
	Switch_Win_Id(Macro_Window);
RET;
/*******************************************************************************/

END_OF_MAC:
	while(  (box_count > bc) & (box_count > 0)  ) {
		kill_box;
	}

	if(  (Switch_Win_Id(Macro_Window))  ) {
		Delete_Window;
	}
/* clean up altered system variables */
	Reg_Exp_Stat = T_Reg_Exp_Stat;
	Undo_Stat = True;
	Tab_Expand = T_Tab_Expand;
	Insert_Mode = T_Insert_Mode;

	backups = t_backups;
}


macro REPLACE_HEADER {
/*******************************************************************************
																MULTI-EDIT MACRO

Name: REPLACE HEADER

Description: Replaces headers in DB files.

							 (C) Copyright 1991 by American Cybernetics, Inc.
*******************************************************************************/
	int Source_Window = Parse_Int('/SW=',MParm_Str),
					Target_Window = Parse_Int('/TW=',MParm_Str),
					T_Win_Num,
					Place_Regardless = Parse_Int('/PL=',Mparm_Str),
					Exit_No_Target = Parse_Int('/ENT=',Mparm_Str),
					replace_data = Parse_Int('/RD=', mparm_str ),
					Include_Records = Parse_int('/IR=',Mparm_Str),
					Header_Not_Needed = Parse_int("/HNN=",Mparm_str),
					Exit_With_Target = Parse_int("/EWT=",Mparm_str),
					Field_Count = 0,
					t_int,
					t_insert_mode = insert_mode,
					t_reg_exp_stat = reg_exp_stat,
					t_ignore_case = ignore_case,
					NO_Header_replace = parse_int("/NHR=",Mparm_str),
					add_count = 0;
					;
	str Source_Page_Title = Parse_Str('/SPT=',MParm_Str),
					Target_Page_Title = Parse_Str('/TPT=',MParm_Str),
					Header_Page_Title = Parse_Str('/HPT=',MParm_Str),
					source_field[2048],
					target_field[2048],
					dbf,
					t_return_str = return_str;
					;

	Return_Int = 0;

/* Make sure we have all the necessary parameters */
	if ((Switch_Win_Id(Source_Window) == False) ||
		(Switch_Win_Id(Target_Window) == False) ||
			(Source_Page_Title == '')) {
		Return_Int = 1; /* Necessary parameters not found */
		Goto EXIT;
	}
	if (Include_Records) {
		if (Header_Page_Title == "") {
			Header_Page_title = source_page_title;
		}
// get all the data from the header
		Switch_Win_Id(Source_Window);
		Tof;
		Ignore_Case = True;
		Reg_Exp_Stat = True;
		if (Search_Fwd('%|12' + Header_Page_Title + '$|| ',0) == 0) {
			Return_Int = 2; /* Source data not found */
			Goto EXIT;
		}
// Skip past any @ commands
		do {
			down;
		} while (cur_char == '@');

		while ((!xpos(cur_char,'*|12',1)) && (!at_eof)) {
			++field_count;
			set_global_str("@T_DBF_" + str(field_count),
				parse_Str("/DBF=",get_line));
			down;
		}
		if (field_count < 1) {
			Return_Int = 2; /* Source data not found */
			Goto EXIT;
		}
	}

	Switch_Win_Id(Source_Window);
	Tof;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (Search_Fwd('%|12' + Source_Page_Title + '$|| ',0) == 0) {
NO_SOURCE_HEADER:
		Return_Int = 2; /* Source data not found */
		Goto EXIT;
	}
	if (no_header_replace) {
		return_int = 0;
//		goto PUT_RECORDS;
		goto NHO1;
	}

	Down;
	Block_Begin;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
/*
	if (Include_Records) {
		if (Search_Fwd('%|12',0)) {
			up;
		} else {
			Eof;
			if (C_Col == 1) {
				Up;
			}
		}
	} else {
*/
		if (Search_Fwd('%{|12}||{@*@*@*@*START@*@*@*@*$}',0) == 0) {
			Goto NO_SOURCE_HEADER;
		}
		if (Cur_Char == '|12') {
			Goto NO_SOURCE_HEADER;
		}
/*
	}
*/

	Block_End;

	T_Win_Num = Cur_Window;

NHO1:
	Switch_Win_Id(Target_Window);
	Tof;
	if (Target_Page_Title != '') {
		if (Target_Page_Title == '-1') {
/* Special case for KEYMAP.DB */
			Goto NO_TARGET_DPT;
		}
		Ignore_Case = True;
		Reg_Exp_Stat = True;
		if (Search_Fwd('%|12' + Target_Page_Title + '$|| ',0) == 0) {
			if (Place_Regardless == 0) {
				if (Exit_No_Target == 0) {
/* /ENT=1 means EXIT NO TARGET i.e. don't attempt to update header if the header
does not exist.    This is intended for professional configuration options not
present in standard version */
NO_TARGET_HEADER:
					Return_Int = 3; /* Target data not found */
				}
				Goto EXIT;
			}
			Eof;
			if (C_Col > 1) {
				Down;
			}
			Put_Line('|12' + Target_Page_Title);
			if (no_header_replace) {
				goto PUT_RECORDS;
			}

			Down;
			Goto NO_EXISTING_HEADER;
		} else if (Exit_With_Target) {
			goto EXIT;
		}
		Down;
	}

	if (no_header_replace) {
		goto PUT_RECORDS;
	}

NO_TARGET_DPT:
	Block_Begin;
	Ignore_Case = True;
	Reg_Exp_Stat = True;
	if (Search_Fwd('%{|12}||{@*@*@*@*START@*@*@*@*$}',0) == 0) {
		if (Header_Not_Needed) {
			goto NO_EXISTING_HEADER;
		}
		Eof;
		if (C_Col == 1) {
			up;
		}
	}
	if (Cur_Char == '|12') {
		if (Header_Not_Needed) {
			goto NO_EXISTING_HEADER;
		}
		up;
	}
	if( replace_data ) {
		if(search_fwd('%|12',0))
			up;
		else
			eof;
	}
	Block_End;
	Delete_Block;

NO_EXISTING_HEADER:
	Window_Copy(T_Win_Num);

PUT_RECORDS:
	if (include_records) {
// find beginning of records in source file
		switch_win_id(source_window);
		RM("POSITION_DB /#=1/NDF=1/F=" + file_name + "/DPT=" +
			source_page_title);
		if (return_int < 1) {
			Return_Int = 2; /* Source data not found */
			Goto EXIT;
		}
		goto_col(1);
		while ((cur_char != '|12') && (get_line != "")) {
			set_global_str("@SOURCE_RECORD",get_line);
			switch_win_id(target_window);
			RM("POSITION_DB /GLO=@TARGET_RECORD/NDF=1/F=" + file_name + "/DPT=" +
				target_page_title + "/DBF=" + global_str("@T_DBF_1") + "/FV=" +
				parse_str("" + global_str("@T_DBF_1") + "=",
				global_str("@SOURCE_RECORD")));
			if (return_int < -1) {
				Return_Int = 3; /* Target data not found */
				goto EXIT;
			}
			if (return_int == 1) {
// this means the target has the same record need to put in any missing fields
				for (t_int = 1; t_int <= field_count; ++t_int) {
					dbf = "" + global_str("@T_DBF_" + str(t_int)) + "=";
					source_field = parse_str(dbf,global_str("@SOURCE_RECORD"));
					target_field = parse_str(dbf,global_str("@TARGET_RECORD"));

					if (svl(target_field) && (target_field != source_field)) {
/* We can't use CHNGPARM here because the field is passed in MPARM_STR and
   has a max length of less than 255 chars.  Some of the fields can exceed
   that
						return_str = dbf;
						RM("CHNGPARM /G=@SOURCE_RECORD/P=" + target_field);
*/
						str g_str[2048] = Global_Str("@SOURCE_RECORD");

						Return_Int = XPos(dbf,G_Str,1);
						if (Return_Int) {
							var_remove_str(dbf,g_str);
						} else {
							Return_Int = svl(g_str) + 1;
						}

						Set_Global_Str("@SOURCE_RECORD",
							str_ins(dbf + target_field,g_str,return_int));
					}
				}
			} else {
// target did not have the same record, put in a new one
				up;
				goto_line(c_line + add_count);
				++add_count;
/*
				if (at_eof) {
					eof;
					if (c_col == 1) {
						up;
					}
				} else if (copy(get_line,1,1) == '|12') {
					up;
				}
*/
				eol;
				insert_mode = true;
				cr;
			}
			put_line(global_str("@SOURCE_RECORD"));
/*
if (global_int("!@#$%")) {
set_global_int("!@#$%",0);
Beep;
refresh = true;
redraw;
make_message(global_str("@SOURCE_RECORD"));
read_key;
if (key1 == 27) {
return_int = 0;
goto EXIT;
}
}
*/
			switch_win_id(source_window);
			down;
		}
	}
	Return_Int = 0;
	GOTO EXIT;

EXIT:
	for (field_count ; field_count > 0 ; --field_count)
			set_global_str("@T_DBF_" + str(field_count), "");
	insert_mode = t_insert_mode;
	reg_exp_stat = t_reg_exp_stat;
	insert_mode = t_insert_mode;
	return_str = t_return_str;
}

macro POSITION_DB {
/*******************************************************************************
THIS IS A SPECIAL VERSION OF GET_DB_RECORD FOR CONV_700
Parameters:
						/F=			Filename
						/NDF=1	Do not delete the window after you are done
						/DPT=		Data page title
						/GLO=		Name of global string to store record
						/DBF=		Field name
						/FV=		Value of field
						/#=			Number of Record to return.  Overrides /DBF= and /FV=.
											Example:  If /#=3 then the 3rd record will be returned.
						/AGLO=	Name of global integer to store total amount of records
										found.  This was added primarily for the macro COMPILE so
										that it can find out it there is only 1 compiler interface
										and bypass the compiler menu.

Returns:
						Return_int = 1 if found
						Return_int = 0 if not found, but first record is stored in /GLO=
						Return_int = -1 if not found and there are no records.
						Return_Int = -2 if the DPT is not found in the DB file.
						Return_Int = -3 if the DB file is not found.

This only works for string and integer fields
*******************************************************************************/
	str F_Name[80] = Caps(Parse_Str('/F=',MParm_Str)),
					DPT[80] = Caps(Parse_Str('/DPT=',MParm_Str));
	int Active_Window = Window_Id,
					Db_Window = 0,
					T_Reg_Exp_Stat = Reg_Exp_Stat,
					T_Ignore_Case = Ignore_Case,
					T_Refresh = Refresh,
					Start_Records,
					Record_Amount,
					Rec_Num = Parse_Int('/#=',Mparm_Str);

	ignore_case = true;
	char Delimit = Parse_Str('/LD=',MParm_Str);
	if(  (Delimit == '|0')  ) {
		Delimit = '';
	}
	Refresh = False;

	RM('Setconfig /DB=' + F_Name + '/T=' + DPT);

	F_Name = Return_Str;
	db_window = window_id;
	if(  (Truncate_Path(F_Name) != Truncate_Path(File_Name))  ) {
			Return_Int = -3;
			Goto EXIT;
	}
/*
	if (Svl(Dpt)) {
		if (Caps(Get_Line) != ('|12' + DPT)) {
			Return_Int = -2;
			Goto EXIT;
		}
	}
*/
	Start_Records = C_Line;
	Eol;
	if (Search_Fwd('%{|12}||{@*@*@*@*START@*@*@*@*}',0)) {
/* If we found a data page title, assume no header in this db */
		if (Cur_Char != '|12') {
			Start_Records = C_Line;
			if(  (Search_Fwd('%|12',0) == False)  ) {
				Eof;
				if(  (C_Col > 1)  ) {
					Down;
				}
			}
		}
	} else {
		Eof;
		if(  (C_Col > 1)  ) {
			Down;
		}
	}
	++Start_Records;
	Record_Amount = C_Line - Start_Records;
	Set_Global_Int(Parse_Str('/AGLO=',MParm_Str),Record_Amount);
	if(  (Record_Amount < 1)  ) {
		Return_Int = -1;
		Goto EXIT;
	}
	if(  (Rec_Num)  ) {
		if(  ((Rec_Num > Record_Amount) | (Rec_Num < 1))  ) {
			Return_Int = 0;
			Goto_Line(Start_Records);
		} else {
			Return_Int = 1;
			Goto_Line(Start_Records + Rec_Num - 1);
		}
	} else {
		Goto_Line(Start_Records);
		Goto_Col(1);
		Return_Int = Search_Fwd(Delimit + Parse_Str('/DBF=',MParm_Str) + '=' +
									make_literal(Parse_Str('/FV=',MParm_Str))  + Delimit + '||$',Record_Amount);
	}
	Set_Global_Str(Parse_Str('/GLO=',MParm_Str),Get_Line);

EXIT:
	if(  (Parse_Int('/NDF=',MParm_Str) == False)  ) {
		if(  (Switch_Win_Id(DB_Window))  ) {
			Delete_Window;
		}
	}
	Reg_Exp_Stat = T_Reg_Exp_Stat;
	Ignore_Case = T_Ignore_Case;
	Switch_Win_Id(Active_Window);
	Refresh = T_Refresh;
}

macro CHECK_KEYMAP TRANS {
/*******************************************************************************
																MULTI-EDIT MACRO

Name:	CHECK_KEYMAP

Description:  Checks and corrects macro file names in the keymap.

							 (C) Copyright 1991 by American Cybernetics, Inc.
*******************************************************************************/

	str Sub_Heading[40],Key_Line[400];
	int Keymap_Window,Data_Window,Pointer;

	Reg_Exp_Stat = True;
	Ignore_Case = True;

	Keymap_Window = Window_Id;
	Data_Window = Parse_Int('/DW=',MParm_Str);

	if (Switch_Win_Id(Data_Window) == 0) {
		Return_Str = '/T=KEYMAP CONVERSION ERROR/M=Window for keymap conversion not found!';
		Goto EXIT;
	}

	Tof;
	if (Search_Fwd('%|12KEYMAP.DB$',0) == 0) {
		Return_Str = '/T=KEYMAP CONVERSION ERROR/M=Data for keymap conversion not found!';
		Goto EXIT;
	}
	if (Search_Fwd('%@*@*@*@*START@*@*@*@*$',0) == 0) {
		Return_Str = '/T=KEYMAP CONVERSION ERROR/M=Data for keymap conversion not found!';
		Goto EXIT;
	}

	Switch_Win_Id(Keymap_Window);
/* First step is to find all macro names that have changed and replace them */
	tof;
	if (Search_Fwd('%{MC=COM_SCREEN_MENU}{?*}{PARAM=/C=1}',0)) {
		replace('MC=COM_SCREEN_OP#1PARAM=/TP=3');
	}
	tof;
	if (Search_Fwd('%{MC=COM_SETUP_MENU}{?*}{PARAM=/BK=1}',0)) {
		replace('MC=COM_MAIN_MENU#1PARAM=/K=S');
	}
	tof;
	if (Search_Fwd('%{MC=CASEMENU}{?*}{PARAM=/U=1}',0)) {
		replace('MC=MENU#1PARAM=/MN=UPPER_CASE');
	}
	tof;
	if (Search_Fwd('%{MC=CASEMENU}{?*}{PARAM=/U=0}',0)) {
		replace('MC=MENU#1PARAM=/MN=LOWER_CASE');
	}

	Switch_Win_Id(Data_Window);
	Sub_Heading = '@*@*@*@*START@*@*@*@*';

MORE_KEYS:
	Down;
	Key_Line = Get_Line;
	if ((XPos('|12',Key_Line,1) != 1) & (At_Eof == False)) {
		if (XPos('@=',Key_Line,1) == 1) {
			Pointer = 5;
			while (Str_Char(Key_Line,Pointer) == '-') {
				++Pointer;
			}
			Sub_Heading = Copy(Key_Line,Pointer,40);
			Pointer = 1;
			while ((Str_Char(Sub_Heading,Pointer) != '-') && (Svl(Sub_Heading) > Pointer)) {
				++Pointer;
			}
			Sub_Heading = Make_Literal(Remove_Space(Copy(Sub_Heading,1,Pointer - 1)));
			Goto MORE_KEYS;
		}
		Switch_Win_Id(Keymap_Window);
		Call CHECK_LINE;
		Switch_Win_Id(Data_Window);
		Goto MORE_KEYS;
	}

	Make_Message('');
	Tof;
	Return_Str = '';
	Goto EXIT;

CHECK_LINE:
	Make_Message('Checking and updating the macro: ' + Parse_Str('MC=',Key_Line));
	Tof;
SEARCH_AGAIN:
	if (Search_Fwd('MC=' + Parse_Str('MC=',Key_Line) + '',0) == 0) {

/* If we can't find the line, add it to the keymap either under the appropriate
subheading or at the end of the file */
/* First, check for a conflict with the key assignments.  If so, strip the
key assignment from the record before inserting it. */
		Tof;
		if (search_fwd("K[12]=" + parse_str("K1=",key_line) + "|$",0)) {
			var_remove_str("K1=",key_line);
		}
		Tof;
		if (search_fwd("K[12]=" + parse_str("K2=",key_line) + "|$",0)) {
			var_remove_str("K2=",key_line);
		}

		Tof;
		if (Search_Fwd(Sub_Heading,0)) {
			Eol;
			Insert_Mode = True;
			Cr;
		} else {
			Eof;
			if (C_Col > 1) {
				Down;
			}
		}

		Put_Line(Key_Line);
		Ret;
	}

	if ((Parse_Str('PARAM=',Get_Line) != Parse_Str('PARAM=',Key_Line)) |
		(Parse_Str('MODE=',Get_Line) != Parse_Str('MODE=',Key_Line))) {
		Eol;
		Goto SEARCH_AGAIN;
	}
/* If we get here, then we found the desired key defintion, so check the macro
file name and correct if neccesary */
	if (Parse_Str('MF=',Get_Line) != Parse_Str('MF=',Key_Line)) {
		if (Search_Fwd('MF=' + Parse_Str('MF=',Get_Line),1)) {
			Replace('MF=' + Parse_Str('MF=',Key_Line));
		} else {
			Eol;
			Text('MF=' + Parse_Str('MF=',Key_Line));
		}

	}
	Goto_Col(1);
	if (Parse_Str('MID=',Get_Line) != Parse_Str('MID=',Key_Line)) {
		if (Search_Fwd('MID=' + Parse_Str('MID=',Get_Line),1)) {
			Replace('MID=' + Parse_Str('MID=',Key_Line));
		} else {
			if ((XPos('MID=',Get_Line,1) == 0) & (XPos('MID=',Key_Line,1) == 0)) {
				Ret;
			}
			Eol;
			Text('MID=' + Parse_Str('MID=',Key_Line));
		}
	}
	Ret;

EXIT:

}

macro CONV_INSTALL DUMP
/*******************************************************************************
																MULTI-EDIT MACRO

Name: CONV_INSTALL

Description: Informs user of instructions for use.

							 (C) Copyright 1991 by American Cybernetics, Inc.
*******************************************************************************/
{
	rm('MEERROR^MessageBox /T=PLEASE NOTE/M=Please follow the instructions supplied in README.DOC to execute the 7.0 converter.');
}
